/** A templated class */
template<class T>
class Template {
public:
    T    value;
    Template(v) : value(v) {}
};

/** A class */
class Class {
public:
    /** A templated typedef. */
    typedef Template<int> TemplateInteger;

    /** A typedef. If TemplateInteger is removed, references to Class::Integer will
        link to here. If TemplateInteger is present, references to Class::Integer
        receive no link!*/
    typedef int Integer;

    /** */
    class Inner {};
};

namespace Namespace {
    /** A typedef */
    typedef Template<int> Integer;

    class ClassB {};
};

/** Another class */
class Bar {
public:
    /** A method */
    static Class::Integer f() {
        return 1;
    }

    /** A method. */
    // The return type is one big link to Template.  It should link Class to Class
    // and TemplateInteger to either Template or the typedef in Class.*/
    static Class::TemplateInteger g() {
        return 1;
    }

    /** Another method */
    static Namespace::Integer h() {
        return 1;
    }

    /** Class::TemplateInteger */
    static void j(Class::TemplateInteger x) {}

    /** Namespace::Integer Namespace::ClassB */
    // In the argument type, Namespace::Integer is one big link to Integer; it should link both Namespace and Integer.
    // In comments, Namespace::Integer has no link; it should be linked to both Namespace and Integer    
    static void k(Namespace::Integer x) {}

    /** */
    static void n(Class::Inner& y) {}

}

/** */
int main(int argc, const char* argv[]) {
    return f();
}
